<template>
  <div class="custom-control custom-switch py-1">
    <input type="checkbox" class="custom-control-input" :id="identifier" v-model="model">
    <label class="custom-control-label" :for="identifier">
      <i v-bind:class="classObject" :title="title"></i>
      <template v-if="notext"></template>
      <template v-else>
        {{ title }}
      </template>
    </label>
  </div>
</template>

<script>
import { createUniqueId } from '@/core/util'

// Mixins
import ParentWorkspaceMixin from '@/dashboard/mixins/ParentWorkspace'


export default {
  name: 'layercheckbox',

  mixins: [
    ParentWorkspaceMixin,
  ],

  data() {
    return {
      identifier: createUniqueId()
    }
  },

  props: {
    layer: {
      type: String,
      required: true,
    },
    icon: {
      type: String,
      default: 'wi-day-sunny',
    },
    notext: {
      type: Boolean,
      default: false,
    },
  },

  computed: {
    workspace: {
      get() {
        return this.$parent.workspace
      }
    },

    title: {
      get() {
        return this.$store.getters.getLayerById(this.layer).title
      }
    },

    classObject: {
      get() {
        let d = {}
        d['wi ' + this.icon] = true
        return d
      },
    },

    model: {
      get() {
        return this.$store.state[this.workspace].layers.find(layer => layer.id === this.layer).active
      },

      set(value) {
        if(value) {
          this.$store.commit(mutationNameResolve(this.workspace, SHOW_LAYER), { id: this.layer })
        } else {
          this.$store.commit(mutationNameResolve(this.workspace, HIDE_LAYER), { id: this.layer })
        }
      },
    },
  },

  methods: {
    createUniqueId() {
      return createUniqueId()
    },
  },
}
</script>

<style scoped>
i.wi {
  width: 1rem;
  text-align: center;
}
</style>
